local FirstLootEver = FirstLootEver
local pairs, select =
	  pairs, select
local localfuncs = (select(2,...))
local GetItemInfo = localfuncs.gii
local GetItemQualityColor = localfuncs.giqc
local UnitName, GetNumRaidMembers, UnitLevel =
	  UnitName, GetNumRaidMembers, UnitLevel

FirstLootEver:RegisterAchievement(1, "Anything goes", "Obtain any item.", "Interface\\Icons\\Spell_Shaman_ImprovedReincarnation", function() return true end, {}, "General", nil, 2)
FirstLootEver:RegisterAchievement(2, "A starter's collection", "Obtain 25 different items",
	"Interface\\Icons\\Achievement_GuildPerk_MobileBanking",
	function(addon)
		if addon:HasAchievement(1) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 25 then
					break
				end
			end
			return (c >= 25)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c>=25 then
					break
				end
			end
			return "Obtain 25 different items", 0, (c>=25), c, 25, (UnitName("player")), 1, 0, c.." / 25", "FirstLootEver_2_1", true
		end,
	},
	"General",
	1,
	3
)
FirstLootEver:RegisterAchievement(3, "I'm all outta titles", "Obtain 50 different items.",
	"Interface\\Icons\\Spell_Arcane_FocusedPower",
	function(addon)
		if addon:HasAchievement(2) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 50 then
					break
				end
			end
			return (c >= 50)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c>=50 then
					break
				end
			end
			return "Obtain 50 different items", 0, (c>=50), c, 50, (UnitName("player")), 1, 0, c.." / 50", "FirstLootEver_3_1", true
		end,
	},
	"General",
	2,
	4
)
FirstLootEver:RegisterAchievement(4, "Three digits", "Obtain 100 different items.",
	"Interface\\Icons\\Achievement_GuildPerk_MobileBanking",
	function(addon)
		if addon:HasAchievement(3) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 100 then
					break
				end
			end
			return (c >= 100)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c>=100 then
					break
				end
			end
			return "Obtain 100 different items", 0, (c>=100), c, 100, (UnitName("player")), 1, 0, c.." / 100", "FirstLootEver_4_1", true
		end,
	},
	"General",
	3,
	5
)
FirstLootEver:RegisterAchievement(5, "Double up", "Obtain 200 different items.",
	"Interface\\AddOns\\FirstLootEver\\DoubleUp",
	function(addon)
		if addon:HasAchievement(4) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 200 then
					break
				end
			end
			return (c >= 200)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 200 then
					break
				end
			end
			return "Obtain 200 different items", 0, (c>=200), c, 200, (UnitName("player")), 1, 0, c.." / 200", "FirstLootEver_5_1", true
		end,
	},
	"General",
	4,
	6
)
FirstLootEver:RegisterAchievement(6, "Tonight We Dine In Hell", "Obtain 300 different items.",
	"Interface\\AddOns\\FirstLootEver\\Sparta",
	function(addon)
		if addon:HasAchievement(5) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 300 then
					break
				end
			end
			return (c >= 300)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 300 then
					break
				end
			end
			return "Obtain 300 different items", 0, (c>=300), c, 300, (UnitName("player")), 1, 0, c.." / 300", "FirstLootEver_6_1", true
		end,
	},
	"General",
	5,
	7
)
FirstLootEver:RegisterAchievement(7,"Are we there yet?", "Obtain 500 different items.",
	"",
	function(addon)
		if addon:HasAchievement(6) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 500 then
					break
				end
			end
			return (c >= 500)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 500 then
					break
				end
			end
			return "Obtain 500 different items", 0, (c>=500), c, 500, (UnitName("player")), 1, 0, c.." / 500", "FirstLootEver_7_1", true
		end,
	},
	"General",
	6,
	8
)
FirstLootEver:RegisterAchievement(8,"Getting there", "Obtain 750 different items.",
	"",
	function(addon)
		if addon:HasAchievement(7) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 750 then
					break
				end
			end
			return (c >= 750)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 750 then
					break
				end
			end
			return "Obtain 750 different items", 0, (c>=750), c, 750, (UnitName("player")), 1, 0, c.." / 750", "FirstLootEver_8_1", true
		end,
	},
	"General",
	7,
	9
)
FirstLootEver:RegisterAchievement(9,"", "Obtain 1000 different items.",
	"",
	function(addon)
		if addon:HasAchievement(8) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 1000 then
					break
				end
			end
			return (c >= 1000)
		end
	end,
	{
		function(addon)
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 1000 then
					break
				end
			end
			return "Obtain 1000 different items", 0, (c>=1000), c, 1000, (UnitName("player")), 1, 0, c.." / 1000", "FirstLootEver_9_1", true
		end,
	},
	"General",
	8,
	nil
)

FirstLootEver:RegisterAchievement(20, "Why do they even buy this?", "Obtain any item of poor quality.",
	"Interface\\Icons\\inv_misc_coin_05",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 0 then
			return true
		end
	end,
	{
	},
	"Poor",
	nil,
	29
)

FirstLootEver:RegisterAchievement(29, "Not Ever Rational Directive", "Obtain every known item of poor quality.",
	"Interface\\Icons\\Achievement_BG_killingblow_startingrock",
	function(addon, id)
		if not ((select(3, GetItemInfo(id))) == 0) then return false end
		for itemID, itemOptions in pairs(localfuncs.itemlist()) do
			if itemOptions[2] == "Poor" then
				if not addon.savedVar.items[itemID] then
					return false
				end
			end
		end
		return true
	end,
	{
	},
	"Poor",
	20,
	nil
)

FirstLootEver:RegisterAchievement(40, "Pretty Common", "Obtain any item of common quality.",
	"Interface\\Icons\\Inv_Misc_Toy_01",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 1 then
			return true
		end
	end,
	{
	},
	"Common",
	nil,
	49
)
FirstLootEver:RegisterAchievement(49, "All the Good White stuff", "Obtain every known item of common quality.",
	"Interface\\Icons\\inv_misc_dust_02",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 1 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Common" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Common",
	40,
	nil
)

FirstLootEver:RegisterAchievement(60, "Of the Boar", "Obtain any item of uncommon quality.",
	"Interface\\Icons\\Spell_Magic_PolymorphPig",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 2 then
			return true
		end
	end,
	{
	},
	"Uncommon",
	nil,
	69
)

FirstLootEver:RegisterAchievement(69, "Randomized Collection", "Obtain every known item of uncommon quality.",
	"Interface\\Icons\\INV_Misc_EngGizmos_20",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 2 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Uncommon" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Uncommon",
	60,
	nil
)

FirstLootEver:RegisterAchievement(80, "A Rare Occurrence", "Obtain any item of rare quality.",
	"Interface\\Icons\\Achievement_Halloween_Smiley_01",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 3 then
			return true
		end
	end,
	{
	},
	"Rare",
	nil,
	89
)
FirstLootEver:RegisterAchievement(89, "They're Blue", "Obtain every known item of rare quality.",
	"Interface\\AddOns\\FirstLootEver\\blue",
	function(addon, id)
		if (select(3, GetItemInfo(id))) == 3 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Rare" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Rare",
	80,
	nil
)

FirstLootEver:RegisterAchievement(100, "Truly Epic", "Obtain any item of epic quality.",
	"Interface\\Icons\\Spell_BurningSoul",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 4 then
			return true
		end
	end,
	{
	},
	"Epic",
	nil,
	109
)

FirstLootEver:RegisterAchievement(109, "You CAN haz epix", "Obtain every known item of epic quality.",
	"Interface\\Icons\\INV_Misc_Gift_02",
	function(addon, id)
		if (select(4, GetItemInfo(id))) == 4 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Epic" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Epic",
	100,
	nil
)

local function raidbelowlevel(x)
	if GetNumRaidMembers()<=1 then return false end
	for i=1, GetNumRaidMembers() do
		if UnitLevel("raid"..i) > x then
			return false
		end
	end
	return true
end
FirstLootEver:RegisterAchievement(110, "Been There Done That", "Obtain an epic quality raid loot item from every expansion while no character in your raid group is above that expansion's maximum level.",
	"Interface\\Icons\\Achievement_Dungeon_HEROIC_GloryOfTheRaider",
	function(addon, id, rd, wr)
		local data = localfuncs.itemlist()
		if data[2]=="Epic" and (select(2,GetInstanceInfo()))=="raid" then
			if data[4] == "TBC" then
				if raidbelowlevel(70) then
					wr(2,true)
				end
			elseif data[4] == "WotLK" then
				if raidbelowlevel(80) then
					wr(3,true)
				end
			elseif data[4] == "Cata" then
				if raidbelowlevel(85) then
					wr(4,true)
				end
			else
				if raidbelowlevel(60) then
					wr(1,true)
				end
			end
			if rd(1) and rd(2) and rd(3) and rd(4) then
				return true
			end
		end
	end,
	{
		function(addon, r)
			local has = r(1)
			return "Classic", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_110_1"
		end,
		function(addon, r)
			local has = r(2)
			return "The Burning Crusade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_110_2"
		end,
		function(addon, r)
			local has = r(3)
			return "Wrath of the Lich King", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_110_3"
		end,
		function(addon, r)
			local has = r(4)
			return "Cataclysm", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_110_4"
		end,
	},
	"Epic",
	nil,
	nil
)


FirstLootEver:RegisterAchievement(120, "Orange is the new Purple","Obtain any item of legendary quality.",
	"Interface\\Icons\\Spell_Fire_Elementaldevastation",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 5 then
			return true
		end
	end,
	{
	},
	"Legendary",
	nil,
	121
)
FirstLootEver:RegisterAchievement(121, "A Dream Come True...", "Obtain one of the legendary quality weapons listed below.",
	"Interface\\Icons\\Achievement_BG_TrueAVShutout",
	function(addon, id)
		if (id == 19019) or (id == 17182) or (id == 32838) or (id == 32837) or (id == 34334) or (id == 46017) or (id == 49623) or (id == 71086) then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[19019]
			return (GetItemInfo(19019)) or "Thunderfury, Blessed Blade of the Windseeker", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 19019, has and "1" or "0", "FirstLootEver_121_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[17182]
			return (GetItemInfo(17182)) or "Sulfuras, Hand of Ragnaros", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 17182, has and "1" or "0", "FirstLootEver_121_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32837]
			return (GetItemInfo(32837)).." (Main Hand)" or "Warglaive of Azzinoth (Main Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32837, has and "1" or "0", "FirstLootEver_121_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32838]
			return (GetItemInfo(32838)).." (Off Hand)" or "Warglaive of Azzinoth (Off Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32838, has and "1" or "0", "FirstLootEver_121_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[34334]
			return (GetItemInfo(34334)) or "Thori'dal, the Stars' Fury", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 34334, has and "1" or "0", "FirstLootEver_121_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[46017]
			return (GetItemInfo(46017)) or "Val'anyr, Hammer of Ancient Kings", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 46017, has and "1" or "0", "FirstLootEver_121_6"
		end,
		function(addon)
			local has = not not addon.savedVar.items[49623]
			return (GetItemInfo(49623)) or "Shadowmourne", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 49623, has and "1" or "0", "FirstLootEver_121_7"
		end,
		function(addon)
			local has = not not addon.savedVar.items[71086]
			return (GetItemInfo(71086)) or "Dragonwrath, Tarecgosa's Rest", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 71086, has and "1" or "0", "FirstLootEver_121_8"
		end,
	},
	"Legendary",
	120,
	122
)
FirstLootEver:RegisterAchievement(122, "Wait for it", "Obtain all of the legendary quality weapons listed below.",
	"Interface\\Icons\\Spell_Holy_AvengineWrath",
	function(addon)
		if addon.savedVar.items[19019] and addon.savedVar.items[17182] and addon.savedVar.items[32838] and addon.savedVar.items[32837] and addon.savedVar.items[34334] and addon.savedVar.items[46017] and addon.savedVar.items[49623] and addon.savedVar.items[71086] then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[19019]
			return (GetItemInfo(19019)) or "Thunderfury, Blessed Blade of the Windseeker", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 19019, has and "1" or "0", "FirstLootEver_122_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[17182]
			return (GetItemInfo(17182)) or "Sulfuras, Hand of Ragnaros", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 17182, has and "1" or "0", "FirstLootEver_122_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32837]
			return (GetItemInfo(32837)).." (Main Hand)" or "Warglaive of Azzinoth (Main Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32837, has and "1" or "0", "FirstLootEver_122_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[32838]
			return (GetItemInfo(32838)).." (Off Hand)" or "Warglaive of Azzinoth (Off Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32838, has and "1" or "0", "FirstLootEver_122_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[34334]
			return (GetItemInfo(34334)) or "Thori'dal, the Stars' Fury", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 34334, has and "1" or "0", "FirstLootEver_122_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[46017]
			return (GetItemInfo(46017)) or "Val'anyr, Hammer of Ancient Kings", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 46017, has and "1" or "0", "FirstLootEver_122_6"
		end,
		function(addon)
			local has = not not addon.savedVar.items[49623]
			return (GetItemInfo(49623)) or "Shadowmourne", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 49623, has and "1" or "0", "FirstLootEver_122_7"
		end,
		function(addon)
			local has = not not addon.savedVar.items[71086]
			return (GetItemInfo(71086)) or "Dragonwrath, Tarecgosa's Rest", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 71086, has and "1" or "0", "FirstLootEver_122_8"
		end,
	},
	"Legendary",
	121,
	129
)
FirstLootEver:RegisterAchievement(129, "Just too much spare time", "Obtain every known item of legendary quality.",
	"Interface\\Icons\\Achievement_Dungeon_GloryOfTheRaider",
	function(addon, id)
		if addon:HasAchievement(122) and ((select(3,GetItemInfo(id))) == 5) then
			for itemID, itemOptions in ipairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Legendary" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Legendary",
	122,
	nil
)

FirstLootEver:RegisterAchievement(140, "An Eye for The Eye", "Loot one of the legendary weapons during the Kael'thas Sunstrider encounter in The Eye of Tempest Keep.",
	"Interface\\Icons\\Ability_Hibernation",
	function(addon, id)
		if (id == 30317) or (id == 30316) or (id == 30312) or (id == 30318) or (id == 30313) or (id == 30311) then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[30317]
			return (GetItemInfo(30317)) or "Cosmic Infuser", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30317, has and "1" or "0", "FirstLootEver_140_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30316]
			return (GetItemInfo(30316)) or "Devastation", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30316, has and "1" or "0", "FirstLootEver_140_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30312]
			return (GetItemInfo(30312)) or "Infinity Blade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30312, has and "1" or "0", "FirstLootEver_140_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30318]
			return (GetItemInfo(30318)) or "Netherstrand Longbow", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30318, has and "1" or "0", "FirstLootEver_140_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30313]
			return (GetItemInfo(30313)) or "Staff of Disintegration", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30313, has and "1" or "0", "FirstLootEver_140_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30311]
			return (GetItemInfo(30311)) or "Warp Slicer", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30311, has and "1" or "0", "FirstLootEver_140_6"
		end,
	},
	"Legendary",
	nil,
	141
)
FirstLootEver:RegisterAchievement(141, "Eyeing Completion", "Loot every legendary weapon during the Kael'thas Substrider encounter in The Eye of Tempest Keep.",
	"Interface\\Icons\\Ability_Hunter_AspectOfTheViper",
	function(addon, id)
		if addon.savedVar.items[30317] and addon.savedVar.items[30316] and addon.savedVar.items[30312] and addon.savedVar.items[30318] and addon.savedVar.items[30313] and addon.savedVar.items[30311] then
			return true
		end
	end,
	{
		function(addon)
			local has = not not addon.savedVar.items[30317]
			return (GetItemInfo(30317)) or "Cosmic Infuser", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30317, has and "1" or "0", "FirstLootEver_140_1"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30316]
			return (GetItemInfo(30316)) or "Devastation", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30316, has and "1" or "0", "FirstLootEver_140_2"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30312]
			return (GetItemInfo(30312)) or "Infinity Blade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30312, has and "1" or "0", "FirstLootEver_140_3"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30318]
			return (GetItemInfo(30318)) or "Netherstrand Longbow", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30318, has and "1" or "0", "FirstLootEver_140_4"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30313]
			return (GetItemInfo(30313)) or "Staff of Disintegration", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30313, has and "1" or "0", "FirstLootEver_140_5"
		end,
		function(addon)
			local has = not not addon.savedVar.items[30311]
			return (GetItemInfo(30311)) or "Warp Slicer", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30311, has and "1" or "0", "FirstLootEver_140_6"
		end,
	},
	"Legendary",
	140,
	nil
)

FirstLootEver:RegisterAchievement(221, "Raiding Veteran: The Burning Crusade", "Obtain at least one non-\"Gladiator\" epic item with the item levels listed below.",
	"Interface\\Icons\\spell_holy_championsbond",
	function(addon,id)
		local name,_,_,itemlevel = GetItemInfo(id)
		if (itemlevel == 125) or (itemlevel == 128) or (itemlevel == 134) or (itemlevel == 138) or (itemlevel == 141) or (itemlevel == 151) or (itemlevel == 154) or (itemlevel == 156) or (itemlevel == 159) or (itemlevel == 164) then
			local hasLevels = {}
			for itemID in pairs(addon.savedVar.items) do
				local name,_,_,itemlevel = GetItemInfo(id)
				if not name:find("Gladiator") and ((itemlevel == 141) or (itemlevel == 125) or (itemlevel == 128) or (itemlevel == 134) or (itemlevel == 138) or (itemlevel == 141) or (itemlevel == 151) or (itemlevel == 154) or (itemlevel == 156) or (itemlevel == 159) or (itemlevel == 164)) then
					hasLevels[(itemlevel==156) and 154 or itemlevel] = true
				end
			end
			if hasLevels[125] and hasLevels[128] and hasLevels[134] and hasLevels[138] and hasLevels[141] and hasLevels[151] and hasLevels[154] and hasLevels[159] and hasLevels[164] then
				return true
			end
		end
	end,
	{
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 125) and not n:find("Gladiator") then
					return "Item level 125", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_1"
				end
			end
			return "Item level 125", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_1"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 128) and not n:find("Gladiator") then
					return "Item level 128", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_2"
				end
			end
			return "Item level 128", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_2"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 134) and not n:find("Gladiator") then
					return "Item level 134", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_3"
				end
			end
			return "Item level 134", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_3"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 138) and not n:find("Gladiator") then
					return "Item level 138", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_4"
				end
			end
			return "Item level 138", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_4"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 141) and not n:find("Gladiator") then
					return "Item level 141", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_5"
				end
			end
			return "Item level 141", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_5"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 151) and not n:find("Gladiator") then
					return "Item level 151", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_6"
				end
			end
			return "Item level 151", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_6"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if ((l == 154) or (l == 156)) and not n:find("Gladiator") then
					return "Item level 154", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_7"
				end
			end
			return "Item level 154", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_7"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 159) and not n:find("Gladiator") then
					return "Item level 159", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_8"
				end
			end
			return "Item level 159", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_8"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 164) and not n:find("Gladiator") then
					return "Item level 164", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_221_9"
				end
			end
			return "Item level 164", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_221_9"
		end,
	},
	"The Burning Crusade",
	nil,
	nil
)

FirstLootEver:RegisterAchievement(220, "Raiding Veteran: Wrath of the Lich King", "Obtain at least one non-\"Gladiator\" epic item with the item levels listed below.",
	"Interface\\Icons\\inv_misc_frostemblem_01",
	function(addon,id)
		local name,_,_,itemlevel = GetItemInfo(id)
		if (itemlevel == 200) or (itemlevel == 213) or (itemlevel == 219) or (itemlevel == 226) or (itemlevel == 239) or (itemlevel == 232) or (itemlevel == 245) or (itemlevel == 251) or (itemlevel == 264) or (itemlevel == 277) or (itemlevel == 284) then
			local hasLevels = {}
			for itemID in pairs(addon.savedVar.items) do
				local name,_,_,itemlevel = GetItemInfo(id)
				if not name:find("Gladiator") and ((itemlevel == 200) or (itemlevel == 213) or (itemlevel == 219) or (itemlevel == 226) or (itemlevel == 239) or (itemlevel == 232) or (itemlevel == 245) or (itemlevel == 251) or (itemlevel == 264) or (itemlevel == 277) or (itemlevel == 284)) then
					hasLevels[itemlevel] = true
				end
			end
			if hasLevels[200] and hasLevels[213] and hasLevels[219] and hasLevels[226] and hasLevels[239] and hasLevels[232] and hasLevels[245] and hasLevels[251] and hasLevels[264] and hasLevels[277] and hasLevels[284] then
				return true
			end
		end
	end,
	{
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 200) and not n:find("Gladiator") then
					return "Item level 200", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_1"
				end
			end
			return "Item level 200", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_1"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 213) and not n:find("Gladiator") then
					return "Item level 213", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_2"
				end
			end
			return "Item level 213", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_2"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 219) and not n:find("Gladiator") then
					return "Item level 219", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_3"
				end
			end
			return "Item level 219", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_3"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 226) and not n:find("Gladiator") then
					return "Item level 226", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_4"
				end
			end
			return "Item level 226", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_4"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 232) and not n:find("Gladiator") then
					return "Item level 232", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_5"
				end
			end
			return "Item level 232", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_5"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 239) and not n:find("Gladiator") then
					return "Item level 239", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_6"
				end
			end
			return "Item level 239", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_6"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 245) and not n:find("Gladiator") then
					return "Item level 245", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_7"
				end
			end
			return "Item level 245", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_7"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 251) and not n:find("Gladiator") then
					return "Item level 251", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_8"
				end
			end
			return "Item level 251", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_8"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 264) and not n:find("Gladiator") then
					return "Item level 264", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_9"
				end
			end
			return "Item level 264", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_9"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 277) and not n:find("Gladiator") then
					return "Item level 277", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_10"
				end
			end
			return "Item level 277", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_10"
		end,
		function(addon)
			for itemID in pairs(addon.savedVar.items) do
				local n,_,_,l = GetItemInfo(itemID)
				if (l == 284) and not n:find("Gladiator") then
					return "Item level 284", 0, true, 1, 1, (UnitName("player")), 0, 0, "1", "FirstLootEver_220_11"
				end
			end
			return "Item level 284", 0, false, 0, 1, nil, 0, 0, "0", "FirstLootEver_220_11"
		end,
	},
	"Wrath of the Lich King",
	nil,
	nil
)

FirstLootEver:RegisterAchievement(200, "Cataclysmic Collector", "Obtain at least one new item while in each of the listed zones.",
	"Interface\\Icons\\Achievement_Zone_Cataclysm",
	function(addon,_,r,w)
		local z = GetRealZoneText()
		if z == "Mount Hyjal" then
			w(1,true)
		elseif z == "Vashj'ir" then
			w(2,true)
		elseif z == "Deepholm" then
			w(3,true)
		elseif z == "Uldum" then
			w(4,true)
		elseif z == "Twilight Highlands" then
			w(5,true)
		end
		if r(1) and r(2) and r(3) and r(4) and r(5) then
			return true
		end
	end,
	{
		function(addon, r)
			local has = r(1)
			return "Mount Hyjal", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_200_1"
		end,
		function(addon, r)
			local has = r(2)
			return "Vashj'ir", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_200_2"
		end,
		function(addon, r)
			local has = r(3)
			return "Deepholm", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0,  has and "1" or "0", "FirstLootEver_200_3"
		end,
		function(addon, r)
			local has = r(4)
			return "Uldum", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_200_4"
		end,
		function(addon, r)
			local has = r(5)
			return "Twilight Highlands", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0", "FirstLootEver_200_5"
		end,
	},
	"Cataclysm",
	nil,
	nil
)
			
	
-- metas start at 1k. they need to be registered after all others are done to parse just-completed achievements properly
FirstLootEver:RegisterAchievement(1000, "Let's all be friends together", "Obtain at least one item of every quality.",
	"Interface\\Icons\\Achievement_DoubleRainbow",
	function(addon)
		if addon:HasAchievement(20) and addon:HasAchievement(40) and addon:HasAchievement(60) and addon:HasAchievement(60) and addon:HasAchievement(80) and addon:HasAchievement(100) and addon:HasAchievement(120) then
			return true
		end
	end,
	{
		function(addon)
			local has = addon:HasAchievement(20)
			return "Poor", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_20", has and "1" or "0", "FirstLootEver_1000_1"
		end,
		function(addon)
			local has = addon:HasAchievement(40)
			return "Common", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_40", has and "1" or "0", "FirstLootEver_1000_2"
		end,
		function(addon)
			local has = addon:HasAchievement(60)
			return "Uncommon", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_60", has and "1" or "0", "FirstLootEver_1000_3"
		end,
		function(addon)
			local has = addon:HasAchievement(80)
			return "Rare", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_80", has and "1" or "0", "FirstLootEver_1000_4"
		end,
		function(addon)
			local has = addon:HasAchievement(100)
			return "Epic", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_100", has and "1" or "0", "FirstLootEver_1000_5"
		end,
		function(addon)
			local has = addon:HasAchievement(120)
			return "Legendary", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_120", has and "1" or "0", "FirstLootEver_1000_6"
		end,
	},
	"",
	nil,
	1001
)

FirstLootEver:RegisterAchievement(1001, "Beat The Game", "Obtain every single known item.",
	"Interface\\AddOns\\FirstLootEver\\all",
	function(addon)
		if addon:HasAchievement(29) and addon:HasAchievement(49) and addon:HasAchievement(69) and addon:HasAchievement(89) and addon:HasAchievement(109) and addon:HasAchievement(129) then
			return true
		end
	end,
	{
		function(addon)
			local has = addon:HasAchievement(29)
			return "Every known poor item.", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_29", has and "1" or "0", "FirstLootEver_1001_1"
		end,
		function(addon)
			local has = addon:HasAchievement(49)
			return "Every known common item.", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_49", has and "1" or "0", "FirstLootEver_1001_2"
		end,
		function(addon)
			local has = addon:HasAchievement(69)
			return "Every known uncommon item.", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_69", has and "1" or "0", "FirstLootEver_1001_3"
		end,
		function(addon)
			local has = addon:HasAchievement(89)
			return "Every known rare item.", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_89", has and "1" or "0", "FirstLootEver_1001_4"
		end,
		function(addon)
			local has = addon:HasAchievement(109)
			return "Every known epic item.", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_109", has and "1" or "0", "FirstLootEver_1001_5"
		end,
		function(addon)
			local has = addon:HasAchievement(129)
			return "Every known legendary item.", 8, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, "FirstLootEver_129", has and "1" or "0", "FirstLootEver_1001_6"
		end,
	},
	"",
	1000,
	nil
)




FirstLootEver:RegisterAchievement(1339, "Alpha tester", "Be awesome enough to help with development.",
	"Interface\\Icons\\ThumbsUp",
	function()
		return false
	end,
	{
	},
	"",
	nil,
	1338
)
FirstLootEver:RegisterAchievement(1338, "Repository checkout", "Can't wait for new revisions to package, eh?",
	"Interface\\AddOns\\FirstLootEver\\subversion",
	function()
		return false
	end,
	{
	},
	"",
	1339,
	1337
)
		
FirstLootEver:RegisterAchievement(1337, "Who's awesome?", "You're awesome!",
	"Interface\\AddOns\\FirstLootEver\\treeston",
	function()
		return false
	end,
	{
	},
	"",
	1338,
	nil
)


FirstLootEver:RegenerateAchievementCategoryListings()